function dist(x1, y1, x2, y2)
	return math.sqrt((x2 - x1)^2 + (y2 - y1)^2)
end

function rad(x)
	return x * (math.pi / 180)
end

function drawBase()
	local Draw
	for a = 1, #MAP do
		for b = 1, #MAP[a] do
			Draw = true
			for c = 1, #SHADOWCAST do
				if MAP[a][b] == SHADOWCAST[c] then
					Draw = false
				end
			end
			if Draw then
				love.graphics.draw(Tiles[MAP[a][b]], a * 32 - 32, b * 32 - 32)
			end
		end
	end
end



function drawCasters()
	local Draw
	for a = 1, #MAP do
		for b = 1, #MAP[a] do
			Draw = false
			for c = 1, #SHADOWCAST do
				if MAP[a][b] == SHADOWCAST[c] then
					Draw = true
				end
			end
			
			if Draw then
				love.graphics.draw(Tiles[MAP[a][b]], a * 32 - 32, b * 32 - 32)
			end
		end
	end
end


function drawPlayers()
	if PLAYER.STATE == 0 then
		love.graphics.draw(Player[1], PLAYER.X * 32, PLAYER.Y * 32, PLAYER.ROTATION * (math.pi / 180), 1, 1, 16, 11)
	end
end


function drawShadows(inX, inY, Radius, Angle, MaxAngle, MinAngle)
	for a = 1, #SHADOW do

		Corners = {
			{math.atan2((SHADOW[a][2] * 32 - 32) - inY * 32, (SHADOW[a][1] * 32 - 32) - inX * 32), SHADOW[a][1] * 32, SHADOW[a][2] * 32},
			{math.atan2((SHADOW[a][2] * 32 - 32) - inY * 32, (SHADOW[a][3] * 32 - 32) - inX * 32), SHADOW[a][3] * 32, SHADOW[a][2] * 32},
			{math.atan2((SHADOW[a][4] * 32 - 32) - inY * 32, (SHADOW[a][1] * 32 - 32) - inX * 32), SHADOW[a][1] * 32, SHADOW[a][4] * 32},
			{math.atan2((SHADOW[a][4] * 32 - 32) - inY * 32, (SHADOW[a][3] * 32 - 32) - inX * 32), SHADOW[a][3] * 32, SHADOW[a][4] * 32}
		}
		local Min = Corners[1]
		local Max = Corners[1]
			
		if Corners[2][1] > Max[1] then
			Max = Corners[2]
		elseif Corners[2][1] < Min[1] then
			Min = Corners[2]
		end
			
		if Corners[3][1] > Max[1] then
			Max = Corners[3]
		elseif Corners[3][1] < Min[1] then
			Min = Corners[3]
		end
			
		if Corners[4][1] > Max[1] then
			Max = Corners[4]
		elseif Corners[4][1] < Min[1] then
			Min = Corners[4]
		end
		
		if Min == Corners[1] and Max == Corners[3] and (inX * 32) + 32 > Corners[4][2] then
			Min = Corners[2]
			Max = Corners[4]
		end
			
		-- love.graphics.line(inX * 32, inY * 32, (inX * 32) + math.cos(Max[1]) * Radius, (inY * 32) + math.sin(Max[1]) * Radius)
		-- love.graphics.line(inX * 32, inY * 32, (inX * 32) + math.cos(Min[1]) * Radius, (inY * 32) + math.sin(Min[1]) * Radius)
		
		drawX = {}
			
		drawX[1] = Min[2] - 32
		drawX[2] = Min[3] - 32
		drawX[3] = Max[2] - 32
		drawX[4] = Max[3] - 32
		drawX[5] = (inX * 32) + math.cos(Max[1]) * Radius
		drawX[6] = (inY * 32) + math.sin(Max[1]) * Radius
		drawX[7] = (inX * 32) + math.cos(Min[1]) * Radius
		drawX[8] = (inY * 32) + math.sin(Min[1]) * Radius
		
			
			
		if drawX[5] <= 0 and drawX[7] >= #MAP[1] * 32 then
			newDraw = {}
			
			if (inY * 32) < drawX[2] then
				newDraw[1] = drawX[5]
				newDraw[2] = drawX[6]
				newDraw[5] = drawX[7]
				newDraw[6] = drawX[8]
				newDraw[3] = 0
				newDraw[4] = #MAP * 32
				newDraw[7] = #MAP[1] * 32
				newDraw[8] = #MAP * 32
			end
			
			love.graphics.setColor(0, 0, 0)
			love.graphics.polygon("fill", newDraw)
		elseif drawX[7] <= 0 and drawX[5] >= #MAP[1] * 32 then
			newDraw = {}
			
			if (inY * 32) > drawX[2] then
				if drawX[6] > drawX[8] then
					lowY = drawX[6]
				else
					lowY = drawX[8]
				end
				
				newDraw[5] = drawX[5]
				newDraw[6] = drawX[6]
				newDraw[3] = drawX[7]
				newDraw[4] = drawX[8]
				newDraw[7] = 0
				newDraw[8] = 0
				newDraw[1] = #MAP[1] * 32
				newDraw[2] = 0
			end
			
			love.graphics.setColor(0, 0, 0)
			love.graphics.polygon("fill", newDraw)
		end
		love.graphics.setColor(0, 0, 0)
		love.graphics.polygon("fill", drawX)
		love.graphics.setColor(0, 0, 0, 255)
	end
end




function drawHUD()
	
	--Health
	love.graphics.setColor(255, 0, 0)
	love.graphics.rectangle("fill", 0, 0, PLAYER.HEALTH * 2, 20)
	love.graphics.setColor(0, 0, 0)
	love.graphics.print("Health: " .. PLAYER.HEALTH, 5, 4)
	
	--Lantern oil
	love.graphics.setColor(255, 255, 0)
	love.graphics.rectangle("fill", 0, 20, PLAYER.LANTERNOIL * 2, 20)
	love.graphics.setColor(0, 0, 0)
	love.graphics.print("Oil: " .. PLAYER.LANTERNOIL, 5, 24)
end